from selenium.webdriver.support import expected_conditions as exp
from selenium.webdriver.common.by import By
from appium.webdriver.common.mobileby import MobileBy
from selenium.webdriver.support.wait import WebDriverWait

class BasePage:
    """Page 封装的是公共类 所有测试类都基础该基类"""
    # Page encapsulates a common class. All test classes are based on that base class.
    def __init__(self,driver,path=None,timeout=10):
        """
        :param driver:
        :param timeout:
        :param path:
        """
        self.driver = driver

        self.url =  "http://www.baidu.com"
        #全局元素定位等待
        self.driver.implicitly_wait(timeout)

        self.open(path)



    def open(self,path=None):
        if path == None:
            url = None
        else:
            url = path
        if url != None:
            return self.driver.get(url)


    def run_script(self, js=None):
        """
        run JavaScript script
        """
        if js is None:
            raise ValueError("Please input js script")
        else:
            return self.driver.execute_script(js)








# Map PageElement constructor arguments to webdriver locator enums
LOCATOR_LIST = {
    # selenium
    'css': By.CSS_SELECTOR,
    'id_': By.ID,
    'name': By.NAME,
    'xpath': By.XPATH,
    'link_text': By.LINK_TEXT,
    'partial_link_text': By.PARTIAL_LINK_TEXT,
    'tag': By.TAG_NAME,
    'class_name': By.CLASS_NAME,

    # appium
    'ios_uiautomation': MobileBy.IOS_UIAUTOMATION,
    'ios_predicate': MobileBy.IOS_PREDICATE,
    'ios_class_chain': MobileBy.IOS_CLASS_CHAIN,
    'android_uiautomator': MobileBy.ANDROID_UIAUTOMATOR,
    'android_viewtag': MobileBy.ANDROID_VIEWTAG,
    'android_datamatcher': MobileBy.ANDROID_DATA_MATCHER,
    'accessibility_id': MobileBy.ACCESSIBILITY_ID,
    'image': MobileBy.IMAGE,
    'custom': MobileBy.CUSTOM,
}
list = {
    'css': By.CSS_SELECTOR,
    'id': By.ID,
    'name': By.NAME,
    'xpath': By.XPATH,
    'link_text': By.LINK_TEXT,
    'partial_link_text': By.PARTIAL_LINK_TEXT,
    'tag': By.TAG_NAME,
    'class_name': By.CLASS_NAME,
}
class pageElement(object):
    def __init__(self,driver):
        self.driver = driver

    def input_element(self,By,element,values,describe=None):
        """
        :param driver:
        :param By:
        :param element:
        :param valuse:
        :param describe:
        :return:
        """
        describe = describe
        bys = By
        if By == By:
            return self.webDriverWait(driver=self.driver,by=(list[By],element)).send_keys(values)





    def webDriverWait(self,driver, by, timeout=5, pall=0.5):
        """
        driver 浏览器实例对象
        timeout 等待的实际时间
        poll 刷新间隔
        :return:
        """
        try:
            element = WebDriverWait(driver, timeout, pall).until(
                # 直到被定位的元素被找到
                exp.presence_of_element_located(by)
            )
            return element
        except:
            print("元素定位失败,你可以尝试修改下 %s" % str(by))

    def button_element(self,By,element,describe=None):
        desctibe = describe
        if By == By:
            return self.webDriverWait(driver=self.driver,by=(list[By],element)).click()

