from .ObjectPageElement import BasePage
from selenium.webdriver.common.action_chains import ActionChains
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support.ui import Select


class page(BasePage):

    def max_window(self):
        return self.driver.maximize_window()

    def size_window(self,x,y):
        return self.driver.set_window_size(x,y)

    def context_click(self,xpath=None):
        right = self.driver.find_element_by_xpath(xpath)
        # 对定位到的元素执行鼠标右键操作
        return ActionChains(self.driver).context_click(right).perform()

    def double_click(self,xpath=None):

        # 定位到要双击的元素
        double = self.driver.find_element_by_xpath(xpath)
        # 对定位到的元素执行鼠标双击操作
        return ActionChains(self.driver).double_click(double).perform()

    def drag_and_drop(self,x_name=None,y_name=None):
        element = self.driver.find_element_by_name(x_name)
        # 定位元素的原位置
        target = self.driver.find_element_by_name(y_name)
        # 定位元素要移动到的目标位置
        return ActionChains(self.driver).drag_and_drop(element, target).perform()
        # 执行元素的移动操作

    def shear_input(self,id=None):
        return self.driver.find_element_by_id(id).send_keys(Keys.CONTROL, 'x')

    def re_enter_content(self,id=None):
        return self.driver.find_element_by_id(id).send_keys(Keys.CONTROL,'v')

    def wait(self,timeout=5):
        self.driver.implicitly_wait(timeout)

    @property
    def source_html(self):
        """
        获取当前html源码
        :return:
        """
        p = self.driver.page_source
        return p
    @property
    def title(self):
        p = self.driver.title
        return p

    @property
    def current_url(self):
        p = self.driver.current
        return p



class select_from(object):
    def __init__(self,xpath):
        self.sc = Select(xpath)

    def select_by_index(self,index=0):
        """
        select = Select(sele_obj)
        #根据下标选值
        select.select_by_index(2)
        #根据value属性选值
        select.select_by_value("rtf")
        #根据文本内容选值
        select.select_by_visible_text("Adobe Acrobat PDF (.pdf)")
        :return:
        """
        self.sc.select_by_index(index)

    def select_by_value(self,value=0):
        self.sc.deselect_by_value(value)

    def select_by_visible_text(self,text):
        self.sc.select_by_visible_text(text)



import os,datetime


class Screen(object):
    # def __init__(self,driver):
    #     self.driver = driver

    def shot_save(self,driver,path):
        try:
            sr = datetime.datetime.now().strftime("%Y-%m-%d %H-%M-%S")
            pr = path+'\\'+ sr + '.png'
            driver.save_screenshot(pr)
            print('截图成功！！！')
        except Exception:
            print('截图失败！！！')


def handles(driver=None):
    if driver == None:
        print("错误")
    else:
        n = driver.window_handles
        return n


def switch_windows(driver,key,value):
    driver.switch_to.window(key[value])


def switch_frame(driver,name):
    driver.switch_to.frame(name)


def iframe(driver,element):
    try:
        iframe = driver.find_element_by_xpath(element)
        driver.switch_to.iframe(iframe)
        return iframe
    except:
        print("你的元素定位可能出现了一点小意外,你可以尝试修改下 > %s"%element)


